package doublePEP;
import java.io.*;
import java.util.*;

/**This class creates the randomized trial order for each participant.*/
public class DoubleDataSet{
	/**This method uses a source file to read what trials occur in a block,
	 * randomizes them, and prints the complete sequence of trials to inFile.
	 * @param source The name of the text file containing the task stimuli.
	 * @param nBlocks The number of blocks of trials per participant.
	 * @param isRepalce Replacement selection.
	 * @param nSamples Number of trials.*/
	DoubleDataSet( String s1, String s2 ){
		try{
			//setup output writer and input reader
			FileOutputStream out_1 = new FileOutputStream( "s1_randomized.txt" ) ;
			FileOutputStream out_2 = new FileOutputStream( "s2_randomized.txt" ) ;
			PrintStream pIn_1 = new PrintStream( out_1 ) ;
			PrintStream pIn_2 = new PrintStream( out_2 ) ;
			BufferedReader br_1 = new BufferedReader( new FileReader( s1 ) ) ;
			BufferedReader br_2 = new BufferedReader( new FileReader( s2 ) ) ;

			String trials_1[ ] = new String[ 32 ]; //array of trials
			String trials_2[ ] = new String[ 32 ]; //array of trials
			Random r_1 = new Random() ; //random number generator
			Random r_2 = new Random() ; //random number generator

			for( int line = 0 ; line < 16 ; line ++ ) {
				trials_1[ line ] = new String( br_1.readLine( ) ) ;
				trials_2[ line ] = new String( br_2.readLine( ) ) ;
			}

			for( int trial = 0 ; trial < 16 ; trial++ ) {

				int randNum_1 = r_1.nextInt( 16 - trial ) ;
				pIn_1.println( trials_1[ randNum_1 ] ) ;
				String temp_1 = trials_1[ randNum_1 ] ;
				trials_1[ randNum_1 ] = trials_1[ 16 - trial - 1 ] ;
				trials_1[ 16 - trial - 1 ] = temp_1 ;

				int randNum_2 = r_2.nextInt( 16 - trial ) ;
				pIn_2.println( trials_2[ randNum_2 ] ) ;
				String temp_2 = trials_2[ randNum_2 ] ;
				trials_2[ randNum_2 ] = trials_2[ 16 - trial - 1 ] ;
				trials_2[ 16 - trial - 1 ] = temp_2 ;
			}

			for ( int block = 0 ; block < 10 ; block ++ ) {

				for( int line = 0 ; line < 32 ; line ++ ) {
					trials_1[ line ] = new String( br_1.readLine( ) ) ;
					trials_2[ line ] = new String( br_2.readLine( ) ) ;
				}

				for( int trial = 0 ; trial < 32 ; trial++ ) {
					
					int randNum_1 = r_1.nextInt( 32 - trial ) ;
					pIn_1.println( trials_1[ randNum_1 ] ) ;
					String temp_1 = trials_1[ randNum_1 ] ;
					trials_1[ randNum_1 ] = trials_1[ 32 - trial - 1 ] ;
					trials_1[ 32 - trial - 1 ] = temp_1 ;

					int randNum_2 = r_2.nextInt( 32 - trial ) ;
					pIn_2.println( trials_2[ randNum_2 ] ) ;
					String temp_2 = trials_2[ randNum_2 ] ;
					trials_2[ randNum_2 ] = trials_2[ 32 - trial - 1 ] ;
					trials_2[ 32 - trial - 1 ] = temp_2 ;
				}

			}

			//leave an "END_OF_FILE" marker and close processes
			pIn_1.println( "END_OF_FILE" ) ;
			pIn_2.println( "END_OF_FILE" ) ;
			out_1.close( ) ;
			out_2.close( ) ;
			br_1.close( ) ;
			br_2.close( ) ;
		}

		catch(Exception e){
			System.out.println("Error reading source");
		}
	}
}