package doublePEP;

/**This class defines the operations of DoubleIdentity nodes.*/
public class DoubleIdentity extends DoubleNode{
	/**Total amount of input*/ public static double totInput;

	/**Creates a new DoubleIdentity node.*/
	public DoubleIdentity(){
		super();
		threshold = .3;
	}

	/**Updates activation for each cycle and seraches responses.
	 * @param stimNum Stumulus number.*/
	public void activate( int stimNum, int modelNumber ){
		input = range(input-((totInput-input)*.05)); //5% interference
		update();
		if(activation>threshold){
			double output = (activation-threshold)*java.lang.Math.random()*5;
			if ( modelNumber == 1 ) {
				DoubleRunTime.responses_1[stimNum].input += output;
			} else {
				DoubleRunTime.responses_2[stimNum].input += output;
			}
		}
	}

	/**Clears total input for next cycle.*/
	public static void clear(){
		totInput = 0;
	}
}