package doublePEP;

/**This class defines the operations of DoubleInput nodes.*/
public class DoubleInput extends DoubleNode{
	/**stimulus bias*/   private double bias;
	/**stimulus signal*/ private double signal;

	/**Creates a new DoubleInput node.*/
	public DoubleInput( int nEpisodes ){
		super( nEpisodes ) ;
		threshold = .3;
		bias = 0;
		signal = 0;
	}

	/**Defines the input values for the node.
	 * @param bs Amount of bias for the stimulus.
	 * @param sig Amount of signal for the stimulus.*/
	public void param(double bs,double sig){
		bias = (bs*java.lang.Math.random()) + (bs*java.lang.Math.random());
		bias += bs*java.lang.Math.random();
		bias /= 3; //normally distributed
		signal = sig;
	}

	/**Calls the superclass method and activates DoubleIdentity nodes.
	 * @param stimNum The stimulus number.
	 * @param isConflict Whether semantic conflict is present.*/
	public void activate( int modelNumber, int stimNum, boolean isConflict ) {
		setInput( ) ;
		activate( modelNumber );
		if(isConflict) actOut( stimNum, modelNumber );
		else if(isTarget) actOut( stimNum, modelNumber );
	}

	/**Updates bias and sets the input for cycle.*/
	private void setInput(){
		bias = (bias*.996) + (signal*java.lang.Math.random()*.004);
		input += (bias + java.lang.Math.random())/2;
	}

	/**Sends activation to DoubleIdentity node.
	 * @param stimNum The stimulus number.*/
	public void actOut(int stimNum, int modelNumber){
		if(activation>threshold){
			double output = (activation-threshold)*java.lang.Math.random()*2;
			if(isTarget) output*=3;
			output = range(output);
			if ( modelNumber == 1 ) {
				DoubleRunTime.identities_1[stimNum].input += output;
			} else {
				DoubleRunTime.identities_2[stimNum].input += output; 
			}
			DoubleIdentity.totInput += output;
		}
	}
}