package doublePEP;

/**This DoubleNode subclass defines the operations of DoubleResponse nodes.*/
public class DoubleResponse extends DoubleNode{
 /**Amount of activation retrieved*/ public double retrieved;
 /**Total amount memory retrieved*/  public static double totRetrieved;

 /**Creates a new DoubleResponse node.*/
 public DoubleResponse(){
  super();
  threshold = .45;
  retrieved = 0;
 }

 /**Updates response activation.*/
 public void activate(){
  retrieve();
  update();
 }

 /**Adds retrieved activation to input.*/
 private void retrieve(){
  if(totRetrieved>0){
   double temp = retrieved-((totRetrieved-retrieved)/(DoubleRunTime.nResponses-1));
   if(totRetrieved>1) temp /= totRetrieved;
   temp -= .1;
   input += range(temp,.01);
   retrieved = 0;
  }
 }

 /**Clears totRetrieved for the next cycle.*/
 public static void clear(){
  totRetrieved = 0;
 }
}